Subject: Re: [PATCH v2 2/7] update-index: add --force-full-index option for expand/collapse test

From: Junio C Hamano <[email-masked]>
Date: Fri, 08 Oct 2021 10:11:11 -0700

Elijah Newren <[email-masked]> writes:

>> I see the issue of introducing a test-only option (when sparse index is
>> integrated everywhere, shouldn't it be deprecated?). If there's a way to
>> make this more obviously internal/temporary, I'm happy to modify it. Or, if
>> semi-frequent updates of the command in the test aren't a huge issue, I can
>> revert to V1.
>
> If it's a test-only capability you need, I'd say add it under
> t/helpers/ somewhere, either a new flag for an existing subcommand of
> test-tool, or a new subcommand for test-tool.

Is the ability to force expanding to full index completely useless
in the field?  For diagnosing breakage the end-users may see in the
wild, or perhaps in a specialist usecase for whatever reason working
on full index is preferable and the user may want to force it once
to correct an earlier mistake to enable sparse-index before toggling
the configuration off, or something?

If we do not foresee any such reason, I'd agree it is good to move
that to t/helpers/; otherwise, I think update-index is as good as
any other place, and the option will sit well next to other options
like "--[no-]skip-worktree", "--[no-]assume-unchanged".  It would
most likely need to be used together with "--force-write-index" (or
be made to imply the latter) to be useful, I suspect.

Thanks.